' *** Micro MMPaint for Maximite Col.v4.2 with Mouse serial: v020b by Raros ***
' Test mouse serial 'microsoft mode' compatible
'    with chip HT6513B (4PIN), MM8370 (4PIN), EC3567A1 (4PIN),....
' Interfacing with SP3222E (RS-232 Transceiver 3v-5.5v).
' SP3222E to Maximite:
' pin12(T1in) to MMpin16 - pin13(R1out) to MMpin15 - power gnd/3.3v
'    pin11(T2in) to Gnd.
' SP3222E to RS-232 Male:
' pin8(T2out) to rs232pin7 - pin14(R1in) to rs232pin2
'    pin15(T1out) to rs232pin3 and Gnd to rs232pin5
' Maximite COM1: pin 15 and 16
' *****************************************************************************
Option USB Off
Mode 3:ColFg = 7:ColBg = 0:Color ColFg,ColBg:Cls
PointN = 1: PointX = 0: PointY = 0:Spd = 2:Target = 3
' PointN = Sprite Pointer Type - Spd = Sensibility Mouse - Target = sprite
ClickOn = 0
Sprite Load "pointer7.spr"
GoSub LoadMenu
Sprite On PointN,PointX,PointY

' Dialog Box space
'"123456789012345678901234567890123456789"


Rem  "COMn: baud, buf, int, intlevel, FC, DE, OC"
Open "COM1: 1200, 256, Pointer, 3" As #1


Do While Inkey$ <> Chr$(27): Loop
' Wait 'ESC' key for quit.
Sprite Off PointN:Color 7,0:Cls
Print:Print "   AAARG!!!!"
Print:Print:Memory
End

Pointer:
' A$ = (LButton 32)/(RButton 16)/(NegativeY 8)/(NegativeX 2)
' B$ = MovX --xxxxxx
' C$ = MovY --xxxxxx
A$ = Input$(1,#1)
If (Asc(A$) And 192) <> 192 Then IReturn
' Sync: first byte is 11xxxxxx
B$ = Input$(1,#1):C$ = Input$(1,#1)
'A$ = Input$(1,#1):B$ = Input$(1,#1):C$ = Input$(1,#1)
PointX = PointX + (((Asc(B$) And 63) - (32 * (Asc(A$) And 2)))\Spd)
If PointX < 0 Then
  PointX = 0
 ElseIf PointX > 479 Then
  PointX = 479
EndIf


PointY = PointY + (((Asc(C$) And 63) - (8 * (Asc(A$) And 8)))\Spd)
If PointY < 0 Then
   PointY = 0
 ElseIf PointY > 431 Then
   PointY = 431
EndIf

' Coordinates
If PointY > 63 Then
   Print CLR$(3,0) @(185,36)Format$(PointX,"X=%03.0f")
   Print CLR$(6,0) @(185,49)Format$(PointY-64,"Y=%03.0f")
 Else
   Print CLR$(3,0) @(185,36)"X=---"
   Print CLR$(6,0) @(185,49)"Y=---"
EndIf
'

Sprite move PointN, PointX, PointY


' ****************************************************
Rem                1       2      3     4    5    6     7     8     9      10
On ClickOn GoTo BMPCoor,StLine,EdLine,LBox,RBox,CCirc,RCirc,BlitS,BlitPrw,BlitOk
' Oh No! Again the GoTo
'
'*****************************************************


If PointY < 30 Then
  GoSub Menu1
 ElseIf PointY < 64 Then
  GoSub Menu2
 Else
  GoSub Menu3
EndIf

IReturn

Menu1:
If (Asc(A$) And 32)/32 = 1 Then
If PointX => 320 And PointX < 360 Then Sprite Off PointN:GoSub MouseSpd
If PointX => 360 And PointX < 420 Then GoSub InvFgBk
If PointX => 420 Then GoSub NewCl
If PointX => 40 And PointX < 80 Then Sprite Off PointN:CkOn1 = 0:GoSub Line1
If PointX => 80 And PointX < 120 Then Sprite Off PointN:CkOn1 = 1:GoSub Line1
If PointX => 120 And PointX < 160 Then Sprite Off PointN:CkOn1 = 0:GoSub Box
If PointX => 160 And PointX < 200 Then Sprite Off PointN:CkOn1 = 1:GoSub Box
If PointX => 200 And PointX < 240 Then Sprite Off PointN:CkOn1 = 0:GoSub Circ1
If PointX => 240 And PointX < 280 Then Sprite Off PointN:CkOn1 = 1:GoSub Circ1
If PointX => 280 And PointX < 320 Then Sprite Off PointN:CkOn1 = 0:GoSub Blit1
EndIf

Return

Menu2:
If (Asc(A$) And 32)/32 = 1 Then
If PointX < 60 Then GoSub ClearSc
If PointX => 60 And PointX < 120 Then Sprite Off PointN:GoSub LoadSc
If PointX => 120 And PointX < 180 Then Sprite Off PointN:GoSub SaveSC
EndIf

Return


Menu3:
' ******  Free Draw ******
If (Asc(A$) And 32)/32 = 1 Then
   Sprite Off PointN
   Pixel(PointX,PointY) = ColFg
   Sprite on PointN,PointX,PointY
EndIf
Return


NewCl:
' New Foreground Color
If PointY < 15 Then

   If PointX < 435 Then
     ColFg = 0
    ElseIf PointX > 434 And PointX < 450 Then
     ColFg = 1
    ElseIf PointX > 449 And PointX < 465 Then
     ColFg = 2
    ElseIf PointX > 464 Then
     ColFg = 3
   EndIf

 Else

   If PointX < 435 Then
     ColFg = 4
    ElseIf PointX > 434 And PointX < 450 Then
     ColFg = 5
    ElseIf PointX > 449 And PointX < 465 Then
     ColFg = 6
    ElseIf PointX > 464 Then
     ColFg = 7
   EndIf

EndIf

Line (367,04)-(382,17),ColFg,BF
Color ColFg,ColBg
Return


MouseSpd:
Locate 240,49:Color 7,0:Input "Mouse Speed 1 to 5 ";Spd
GoSub FillDB
If Spd > 5 Or Spd < 1 GoTo MouseSpd
Print CLR$(0,2)@(336,15)Spd
Spd = 6 - Spd
'Color ColFg,ColBg
Sprite On PointN,PointX,PointY
Fake$ = Input$(200,#1):Fake$ = ""
Return


InvFgBk:
' Invert Backgroung and Foreground
Sprite Off PointN
Swap ColFg,ColBg
Line (377,11)-(392,24),ColBg,BF
Line (367,04)-(382,17),ColFg,BF
Color ColFg,ColBg
Sprite On PointN,PointX,PointY
Return


ClearSc:
' Clear screen
Sprite Off PointN
Cls:GoSub LoadMenu
Sprite On PointN,PointX,PointY
Return


LoadSc:
' Load BMP (or MMP > FUTURE)
Locate 240,49:Color 7,0:Input "BMP to Load (* to quit): ";LdSc$
GoSub FillDB
If LdSc$ = "*" Then Sprite on PointN,PointX,PointY:Return
'IF UCASE$(RIGHT$(LdSc$,4))<>".BMP" THEN LdSc$=LdSc$+".BMP"
If UCase$(Right$(LdSc$,4))<>".BMP" Then GoTo LoadSc
Locate 240,49:Color 7,0:Input "Load at TopLeft Screen? (Y/Enter)",answ$
GoSub FillDB
If UCase$(answ$)="Y" Then
  LoadBMP LdSc$,0,64:GoSub FillDB
 Else
  Print CLR$(7,0)@(240,49)" Click on Worckbench for Coordinate"
  ClickOn = 1
EndIf
PointX = 240:PointY = 248
Sprite on PointN,PointX,PointY
Return


BMPCoor:
' ClickOn = 1
If (Asc(A$) And 32)/32 <> 1 Then IReturn
If PointY < 64 Then ClickOn = 0:GoSub FillDB:IReturn
GoSub FillDB
Print CLR$(7,0) @(240,49)"    Loading...."LdSc$
Sprite Off PointN
LoadBMP LdSc$,PointX,PointY
GoSub FillDB
Sprite on PointN,PointX,PointY
ClickOn = 0
IReturn

'********** Draw Line *********************************************

Line1:
Print CLR$(7,0)@(240,49)" Click on Worckbench for Start Line"
ClickOn = 2
'PointX = 240:PointY = 248
PointX = 0:PointY = 64
Pause 200:Fake$ = Input$(20,#1)
Sprite on PointN,PointX,PointY
Return


StLine:
' ClickOn = 2
If (Asc(A$) And 32)/32 <> 1 Then IReturn
If PointY < 64 Then
   If PointY < 30 And PointX => 420 Then
     GoSub NewCl:IReturn
    Else
     ClickOn = 0:CkOn1 = 0:GoSub FillDB:IReturn
   EndIf
EndIf
TmpX1 = PointX:TmpY1 = PointY
Sprite Off PointN
Sprite on Target,TmpX1-4,TmpY1-4
GoSub FillDB
Sprite on PointN,PointX,PointY
If CkOn1 = 0 Then
  Print CLR$(7,0)@(240,49)" Click on Worckbench for End Line"
 Else
  Print CLR$(7,0)@(240,49)" Click on Worckbench for End/Start Line"
EndIf
ClickOn = 3
Pause 200:Fake$ = Input$(20,#1)
IReturn

EdLine:
' ClickOn = 3
If (Asc(A$) And 32)/32 <> 1 Then IReturn
If PointY < 64 Then
  If PointY < 30 And PointX => 420 Then
    GoSub NewCl:IReturn
   Else
    ClickOn = 0:CkOn1 = 0:GoSub FillDB:Sprite off Target:IReturn
  EndIf
EndIf
TmpX2 = PointX:TmpY2 = PointY
GoSub FillDB
Sprite Off PointN
Sprite off Target
If CkOn1 = 0 Then
   Line(TmpX1,TmpY1)-(TmpX2,TmpY2),ColFg
   Sprite on PointN,PointX,PointY
   Print CLR$(7,0)@(240,49)" Click on Worckbench for Start Line"
   ClickOn = 2
 Else
   Line(TmpX1,TmpY1)-(TmpX2,TmpY2),ColFg
   Sprite on Target,TmpX2-4,TmpY2-4
   Sprite on PointN,PointX,PointY
   TmpX1 = TmpX2:TmpY1 = TmpY2
   Print CLR$(7,0)@(240,49)" Click on Worckbench for End/Start Line"
   ClickOn = 3
EndIf
Pause 200:Fake$ = Input$(20,#1)
IReturn

'********** Draw Box **********************************************
Box:
If CkOn1 = 0 Then
   Print CLR$(7,0)@(240,49)" Click on Screen for Left Corner Box"
 Else
   Print CLR$(7,0)@(240,49)"Click on Screen for Left Corner FlBox"
EndIf
ClickOn = 4
'PointX = 240:PointY = 248
PointX = 0:PointY = 64
Sprite on PointN,PointX,PointY
Pause 200:Fake$ = Input$(20,#1)
Return

LBox:
' ClickOn = 4
If (Asc(A$) And 32)/32 <> 1 Then IReturn
If PointY < 64 Then
   If PointY < 30 And PointX => 420 Then
     GoSub NewCl:IReturn
    Else
     ClickOn = 0:CkOn1 = 0:GoSub FillDB:IReturn
   EndIf
EndIf
TmpX1 = PointX:TmpY1 = PointY
Sprite Off PointN
Sprite on Target,TmpX1-4,TmpY1-4
GoSub FillDB
Sprite on PointN,PointX,PointY
If CkOn1 = 0 Then
   Print CLR$(7,0)@(240,49)" Click on Screen for Right Corner Box"
 Else
   Print CLR$(7,0)@(240,49)"Click on Screen for Right Corner FlBox"
EndIf
ClickOn = 5
Pause 200:Fake$ = Input$(20,#1)
IReturn

RBox:
' ClickOn = 5
If (Asc(A$) And 32)/32 <> 1 Then IReturn
If PointY < 64 Then
   If PointY < 30 And PointX => 420 Then
     GoSub NewCl:IReturn
    Else
     ClickOn = 0:CkOn1 = 0:GoSub FillDB:Sprite off Target:IReturn
   EndIf
EndIf
TmpX2 = PointX:TmpY2 = PointY
GoSub FillDB
Sprite Off PointN
Sprite off Target
If CkOn1 = 0 Then
   Line(TmpX1,TmpY1)-(TmpX2,TmpY2),ColFg,B
   Print CLR$(7,0)@(240,49)" Click on Screen for Left Corner Box"
 Else
   Line(TmpX1,TmpY1)-(TmpX2,TmpY2),ColFg,BF
   Print CLR$(7,0)@(240,49)"Click on Screen for Left Corner FlBox"
EndIf
Sprite on PointN,PointX,PointY
ClickOn = 4
Pause 200:Fake$ = Input$(20,#1)
IReturn

'********** Draw Circle *******************************************

Circ1:
If CkOn1 = 0 Then
   Print CLR$(7,0)@(240,49)" Click on Screen for Center Circle"
 Else
   Print CLR$(7,0)@(240,49)"Click on Screen for Center FlCircle"
EndIf
ClickOn = 6
'PointX = 240:PointY = 248
PointX = 0:PointY = 64
Sprite on PointN,PointX,PointY
Pause 200:Fake$ = Input$(20,#1)
Return

CCirc:
' ClickOn = 6
If (Asc(A$) And 32)/32 <> 1 Then IReturn
If PointY < 64 Then
   If PointY < 30 And PointX => 420 Then
      GoSub NewCl:IReturn
    Else
      ClickOn = 0:CkOn1 = 0:GoSub FillDB:IReturn
   EndIf
EndIf
TmpX1 = PointX:TmpY1 = PointY
Sprite Off PointN
Sprite on Target,TmpX1-4,TmpY1-4
GoSub FillDB
Sprite on PointN,PointX,PointY
If CkOn1 = 0 Then
   Print CLR$(7,0)@(240,49)" Click on Screen for Radius Circle"
 Else
   Print CLR$(7,0)@(240,49)" Click on Screen for Radius FlCircle"
EndIf
ClickOn = 7
Pause 200:Fake$ = Input$(20,#1)
IReturn


RCirc:
' ClickOn = 7
If (Asc(A$) And 32)/32 <> 1 Then IReturn
If PointY < 64 Then
   If PointY < 30 And PointX => 420 Then
      GoSub NewCl:IReturn
    Else
      ClickOn = 0:CkOn1 = 0:GoSub FillDB:Sprite off Target:IReturn
   EndIf
EndIf
TmpX2 = PointX:TmpY2 = PointY
' Teorema di Pitagora
Rd = Sqr(((TmpX2-TmpX1)*(TmpX2-TmpX1))+((TmpY2-TmpY1)*(TmpY2-TmpY1)))
GoSub FillDB
Sprite Off PointN
Sprite off Target
If CkOn1 = 0 Then
   Circle(TmpX1,TmpY1),Rd,ColFg
   GoSub LoadMenu
   Print CLR$(7,0)@(240,49)" Click on Screen for Center Circle"
 Else
   Circle(TmpX1,TmpY1),Rd,ColFg,F
   GoSub LoadMenu
   Print CLR$(7,0)@(240,49)" Click on Screen for Center FlCircle"
EndIf
Sprite on PointN,PointX,PointY
ClickOn = 6
Pause 200:Fake$ = Input$(20,#1)
IReturn

'********* Copy with Blit *****************************************

Blit1:
Print CLR$(7,0)@(240,49)"Click on Screen for LeftCorner to Blit"
ClickOn = 8
PointX = 0:PointY = 64
Sprite on PointN,PointX,PointY
Pause 200:Fake$ = Input$(20,#1)
Return

BlitS:
' ClickOn = 8
If (Asc(A$) And 32)/32 <> 1 Then IReturn
If PointY < 64 Then ClickOn = 0:GoSub FillDB:IReturn
TmpX1 = PointX:TmpY1 = PointY
Sprite Off PointN
Sprite on Target,TmpX1-4,TmpY1-4
GoSub FillDB
Sprite on PointN,PointX,PointY
Print CLR$(7,0)@(240,49)"Click on Screen for RightCorner to Blit"
ClickOn = 9
Pause 200:Fake$ = Input$(20,#1)
IReturn


BlitPrw:
' ClickOn = 9
If (Asc(A$) And 32)/32 <> 1 Then IReturn
If PointY < 64 Then ClickOn = 0:GoSub FillDB:Sprite off Target:IReturn
TmpX2 = PointX:TmpY2 = PointY
GoSub FillDB
Sprite Off PointN
Sprite off Target
Line(TmpX1,TmpY1)-(TmpX2,TmpY2),-1,BF
Print CLR$(7,0)@(240,49)"Click Destination for Confirm the Blit"
Sprite on PointN,PointX,PointY
ClickOn = 10
Pause 200:Fake$ = Input$(20,#1)
IReturn

BlitOk:
' ClickOn = 10
If (Asc(A$) And 32)/32 <> 1 Then IReturn
If PointY < 64 Then
   Sprite Off PointN:Line(TmpX1,TmpY1)-(TmpX2,TmpY2),-1,BF
   GoSub Blit1:IReturn
EndIf
TmpX3 = PointX:TmpY3 = PointY
GoSub FillDB
Sprite Off PointN
Line(TmpX1,TmpY1)-(TmpX2,TmpY2),-1,BF
If TmpX2 < TmpX1 Then Swap TmpX2,TmpX1
If TmpY2 < TmpY1 Then Swap TmpY2,TmpY1
TmpW = TmpX2 - TmpX1:TmpH = TmpY2 - TmpY1
BLIT TmpX1,TmpY1,TmpX3,TmpY3,TmpW,TmpH
Sprite on PointN,PointX,PointY
Print CLR$(7,0)@(240,49)"Click on Screen for LeftCorner to Blit"
ClickOn = 8
Pause 200:Fake$ = Input$(20,#1)
IReturn


'********** Fill Dialog Box ***************************************

FillDB:
Rem Clear DIALOG BOX
Line (239,44)-(478,61),0,BF
Color ColFg,ColBg
Return

'********** Load Menu1 ********************************************

LoadMenu:
LoadBMP "menu3h.bmp"
Print CLR$(0,2)@(336,15)6-Spd
Line (377,11)-(392,24),ColBg,BF
Line (367,04)-(382,17),ColFg,BF
If PointY < 64 Then
   Print CLR$(3,0) @(185,36)"X=---"
   Print CLR$(6,0) @(185,49)"Y=---"
 Else
   Print CLR$(3,0) @(185,36)Format$(PointX,"X=%03.0f")
   Print CLR$(6,0) @(185,49)Format$(PointY,"Y=%03.0f")
EndIf
Return

'********** Save Screen *******************************************

SaveSC:
Locate 240,49:Color 7,0:Input "BMP to Save (* to quit): ";SvSc$
If SvSc$ = "*" Then GoSub FillDB:Sprite on PointN,PointX,PointY:Return
Line (0,0)-(479,63),ColBg,BF
Savebmp SvSc$
GoSub LoadMenu
Sprite on PointN,PointX,PointY
Pause 200:Fake$ = Input$(20,#1)
Return


'******************************************************************

Sub Swap a, b
   Local t
   t = a
   a = b
   b = t
End Sub

'************  END  **************************
' Raffaele Rotondo - 82100 Benevento - ITALY
' on Facebbok and Skype:
' raros0101 (also Rotondo Lello - raros_eepc)
'************  END  **************************
